diff -pruN 2.26+dfsg-1/bin/weblint 2.30+dfsg-1/bin/weblint
--- 2.26+dfsg-1/bin/weblint	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/bin/weblint	2017-12-27 17:49:16.000000000 +0000
@@ -5,6 +5,7 @@ use strict;
 
 use Getopt::Long;
 use HTML::Lint;
+use HTML::Lint::Error;
 use HTML::Lint::HTML4;
 
 my $help;
@@ -40,8 +41,7 @@ for my $url ( @ARGV ) {
     my @lines;
     $lint->newfile( $url );
     if ( $url =~ /^https?:/ ) {
-        eval { require LWP::Simple };
-        if ( $@ ) {
+        if ( !eval { require LWP::Simple; 1; } ) {
             warn q{Can't retrieve URLs without LWP::Simple installed};
             next;
         }
diff -pruN 2.26+dfsg-1/Changes 2.30+dfsg-1/Changes
--- 2.26+dfsg-1/Changes	2016-12-30 04:37:22.000000000 +0000
+++ 2.30+dfsg-1/Changes	2018-01-08 04:10:16.000000000 +0000
@@ -6,6 +6,41 @@ NOTE: All bugs and requests are now bein
 
 Please DO NOT send bug reports to http://rt.cpan.org/.
 
+2.30    Sun Jan  7 22:02:25 CST 2018
+    No changes since 2.27_03.
+
+
+2.27_03 Wed Jan  3 17:07:07 CST 2018
+    [FIXES]
+    Removed the text-invalid-entity and attr-invalid-entity, which were
+    for entities that had an invalid numeric value, anything greater
+    than &#65536.  There is no longer a restriction on the numeric values
+    of HTML entities. (GH#60)
+
+
+2.27_02 Wed Dec 27 11:46:28 CST 2017
+    There are be no functionality changes since 2.27_01.
+
+    [INTERNALS]
+    Many Perl::Critic cleanups.
+
+
+2.27_01 Fri Dec 22 15:54:32 CST 2017
+    [ENHANCEMENTS]
+    Adds checking of entities in attributes, not just text.  Thanks,
+    Klaus S. Madsen.
+
+    [FIXES]
+    Calling ->parsefile() would generate an error.  Thanks, Shlomi
+    Fish. (GH#58)
+
+    [INTERNALS]
+    Prepare for perl 5.26.0 which removes '.' from @INC.  Thanks,
+    Jim Keenan.
+
+    Fix disttest target.  Thanks, Shlomi Fish.
+
+
 2.26    Thu Dec 29 22:36:54 CST 2016
     Stable release.  No changes from previous release.
 
diff -pruN 2.26+dfsg-1/debian/changelog 2.30+dfsg-1/debian/changelog
--- 2.26+dfsg-1/debian/changelog	2017-11-12 10:52:25.000000000 +0000
+++ 2.30+dfsg-1/debian/changelog	2018-05-14 14:16:31.000000000 +0000
@@ -1,3 +1,18 @@
+libhtml-lint-perl (2.30+dfsg-1) unstable; urgency=medium
+
+  [ Damyan Ivanov ]
+  * declare conformance with Policy 4.1.3 (no changes needed)
+
+  [ Salvatore Bonaccorso ]
+  * Update Vcs-* headers for switch to salsa.debian.org
+
+  [ Florian Schlichting ]
+  * Import upstream version 2.30+dfsg
+  * Update copyright years
+  * Declare compliance with Debian Policy 4.1.4
+
+ -- Florian Schlichting <fsfs@debian.org>  Mon, 14 May 2018 16:16:31 +0200
+
 libhtml-lint-perl (2.26+dfsg-1) unstable; urgency=medium
 
   * Team upload
diff -pruN 2.26+dfsg-1/debian/control 2.30+dfsg-1/debian/control
--- 2.26+dfsg-1/debian/control	2017-11-12 10:51:34.000000000 +0000
+++ 2.30+dfsg-1/debian/control	2018-05-14 14:16:22.000000000 +0000
@@ -15,9 +15,9 @@ Build-Depends-Indep: devscripts (>= 2.10
                      libtest-pod-coverage-perl (>= 1.04),
                      txt2man,
                      dh-buildinfo
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-perl/packages/libhtml-lint-perl.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-perl/packages/libhtml-lint-perl.git
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/perl-team/modules/packages/libhtml-lint-perl
+Vcs-Git: https://salsa.debian.org/perl-team/modules/packages/libhtml-lint-perl.git
 Homepage: https://metacpan.org/release/HTML-Lint
 
 Package: libhtml-lint-perl
diff -pruN 2.26+dfsg-1/debian/copyright 2.30+dfsg-1/debian/copyright
--- 2.26+dfsg-1/debian/copyright	2017-11-12 10:49:09.000000000 +0000
+++ 2.30+dfsg-1/debian/copyright	2018-05-14 14:13:44.000000000 +0000
@@ -9,14 +9,14 @@ Comment:
     + t/embed-extensions.t
 
 Files: *
-Copyright: 2003-2016, Andy Lester <andy@petdance.com>
+Copyright: 2003-2018, Andy Lester <andy@petdance.com>
 License: Artistic-2.0
 
 Files: debian/*
 Copyright:
  2003-2008, Jonas Smedegaard <dr@jones.dk>
  2009, Antonio Radici <antonio@dyne.org>
- 2012-2015, Florian Schlichting <fsfs@debian.org>
+ 2012-2018, Florian Schlichting <fsfs@debian.org>
 License: Artistic or GPL-1+
 
 License: Artistic
diff -pruN 2.26+dfsg-1/lib/HTML/Lint/Error.pm 2.30+dfsg-1/lib/HTML/Lint/Error.pm
--- 2.26+dfsg-1/lib/HTML/Lint/Error.pm	2016-12-24 04:39:20.000000000 +0000
+++ 2.30+dfsg-1/lib/HTML/Lint/Error.pm	2018-01-08 04:09:01.000000000 +0000
@@ -3,9 +3,8 @@ package HTML::Lint::Error;
 use warnings;
 use strict;
 
-use base 'Exporter';
+use parent 'Exporter';
 
-our @EXPORT = ();
 our @EXPORT_OK = qw( STRUCTURE HELPER FLUFF );
 our %EXPORT_TAGS = ( types => [@EXPORT_OK] );
 
@@ -107,10 +106,12 @@ sub _expand_error {
         $str = "Unknown code: $errcode";
     }
 
-    while ( @_ ) {
-        my $var = shift;
-        my $val = shift;
-        $str =~ s/\$\{$var\}/$val/g if defined $str;
+    if ( defined $str ) {
+        while ( @_ ) {
+            my $var = shift;
+            my $val = shift;
+            $str =~ s/\$\{$var\}/$val/g;
+        }
     }
 
     $self->{_errtext} = $str;
@@ -169,7 +170,8 @@ sub where {
     if ( not ref $_[0] ) {
         $line = shift;
         $col = shift;
-    } else {
+    }
+    else {
         my $self = shift;
         $line = $self->line;
         $col = $self->column;
@@ -232,7 +234,7 @@ for a specific error.
 
 =cut
 
-%errors = (
+%errors = ( ## no critic ( ValuesAndExpressions::RequireInterpolationOfMetachars )
     'api-parse-not-called'     => ['The parse() method has not been called on this file.', CONFIG],
     'api-eof-not-called'       => ['The eof() method has not been called on this file.', CONFIG],
     'config-unknown-directive' => ['Unknown directive "${directive}"', CONFIG],
@@ -251,8 +253,10 @@ for a specific error.
 
     'attr-repeated'            => ['${attr} attribute in <${tag}> is repeated', STRUCTURE],
     'attr-unknown'             => ['Unknown attribute "${attr}" for tag <${tag}>', FLUFF],
+    'attr-unclosed-entity'     => ['Entity ${entity} is missing its closing semicolon', STRUCTURE],
+    'attr-unknown-entity'      => ['Entity ${entity} is unknown', STRUCTURE],
+    'attr-use-entity'          => ['Character "${char}" should be written as ${entity}', STRUCTURE],
 
-    'text-invalid-entity'      => ['Entity ${entity} is invalid', STRUCTURE],
     'text-unclosed-entity'     => ['Entity ${entity} is missing its closing semicolon', STRUCTURE],
     'text-unknown-entity'      => ['Entity ${entity} is unknown', STRUCTURE],
     'text-use-entity'          => ['Character "${char}" should be written as ${entity}', STRUCTURE],
@@ -262,7 +266,7 @@ for a specific error.
 
 You called the C<errors()> method before calling C<parse()> and C<eof()>.
 
-=head2 api-parse-not-called
+=head2 api-eof-not-called
 
 You called the C<errors()> method before calling C<eof()>.
 
@@ -318,10 +322,6 @@ ATTR attribute in C<< <tag> >> is repeat
 
 Unknown attribute "ATTR" for tag C<< <tag> >>.
 
-=head2 text-invalid-entity
-
-Entity ENTITY is invalid
-
 =head2 text-unclosed-entity
 
 Entity ENTITY is missing its closing semicolon
@@ -336,7 +336,7 @@ Character "CHAR" should be written as EN
 
 =head1 COPYRIGHT & LICENSE
 
-Copyright 2005-2016 Andy Lester.
+Copyright 2005-2018 Andy Lester.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the Artistic License v2.0.
diff -pruN 2.26+dfsg-1/lib/HTML/Lint/HTML4.pm 2.30+dfsg-1/lib/HTML/Lint/HTML4.pm
--- 2.26+dfsg-1/lib/HTML/Lint/HTML4.pm	2016-12-22 04:39:15.000000000 +0000
+++ 2.30+dfsg-1/lib/HTML/Lint/HTML4.pm	2018-01-08 04:06:41.000000000 +0000
@@ -24,7 +24,7 @@ this modifies a global table, and is not
 
 =cut
 
-use base 'Exporter';
+use parent 'Exporter';
 our @EXPORT_OK = qw( %isKnownAttribute %isRequired %isNonrepeatable %isObsolete );
 
 sub _hash   { return { map { ($_ => 1) } @_ } }
@@ -60,7 +60,7 @@ our %isKnownAttribute = (
     blockquote  => _hash( @std, qw( cite ) ),
     body        => _hash( @std,
                     qw( alink background bgcolor link marginheight marginwidth onload onunload text vlink ),
-                    _ie_only( qw( bgproperties leftmargin topmargin ) )
+                    _ie_only( qw( bgproperties leftmargin topmargin ) ),
                     ),
     br          => _hash( @core, qw( clear ) ),
     button      => _hash( @std, qw( accesskey disabled name onblur onfocus tabindex type value ) ),
@@ -205,7 +205,7 @@ Andy Lester C<andy at petdance.com>
 
 =head1 COPYRIGHT
 
-Copyright 2005-2016 Andy Lester.
+Copyright 2005-2018 Andy Lester.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the Artistic License v2.0.
diff -pruN 2.26+dfsg-1/lib/HTML/Lint/Parser.pm 2.30+dfsg-1/lib/HTML/Lint/Parser.pm
--- 2.26+dfsg-1/lib/HTML/Lint/Parser.pm	2016-12-30 04:37:31.000000000 +0000
+++ 2.30+dfsg-1/lib/HTML/Lint/Parser.pm	2018-01-08 04:12:04.000000000 +0000
@@ -6,10 +6,11 @@ use strict;
 use HTML::Parser 3.20;
 use HTML::Tagset 3.03;
 
+use HTML::Lint::Error ();
 use HTML::Lint::HTML4 qw( %isKnownAttribute %isRequired %isNonrepeatable %isObsolete );
 use HTML::Entities qw( %char2entity %entity2char );
 
-use base 'HTML::Parser';
+use parent 'HTML::Parser';
 
 =head1 NAME
 
@@ -17,11 +18,11 @@ HTML::Lint::Parser - Parser for HTML::Li
 
 =head1 VERSION
 
-Version 2.26
+Version 2.30
 
 =cut
 
-our $VERSION = '2.26';
+our $VERSION = '2.30';
 
 =head1 SYNOPSIS
 
@@ -52,6 +53,7 @@ sub new {
             text_h             => [ \&_text,           'self,text' ],
             strict_names       => 0,
             empty_element_tags => 1,
+            attr_encoded       => 1,
         );
     bless $self, $class;
 
@@ -130,6 +132,8 @@ sub _start {
             if ( !$validattr->{$attr} ) {
                 $self->gripe( 'attr-unknown', tag => $tag, attr => $attr );
             }
+
+            $self->_entity($val, 'attr');
         } # while attribs
     }
     else {
@@ -161,6 +165,14 @@ sub _start {
 sub _text {
     my ($self,$text) = @_;
 
+    $self->_entity($text, 'text');
+
+    return;
+}
+
+sub _entity {
+    my ($self,$text,$type) = @_;
+
     if ( not $self->{_entity_lookup} ) {
         my @entities = sort keys %HTML::Entities::entity2char;
         # Strip his semicolons
@@ -171,7 +183,7 @@ sub _text {
     while ( $text =~ /([^\x09\x0A\x0D -~])/g ) {
         my $bad = $1;
         $self->gripe(
-            'text-use-entity',
+            $type . '-use-entity',
                 char => sprintf( '\x%02lX', ord($bad) ),
                 entity => $char2entity{ $bad } || '&#' . ord($bad) . ';',
         );
@@ -181,26 +193,27 @@ sub _text {
         my $match = $1;
 
         if ( $match eq '' ) {
-            $self->gripe( 'text-use-entity', char => '&', entity => '&amp;' );
-        } elsif ( $match !~ m/;$/ ) {
+            $self->gripe( $type . '-use-entity', char => '&', entity => '&amp;' );
+        }
+        elsif ( $match !~ m/;$/ ) {
             if ( exists $self->{_entity_lookup}->{$match}
                  || $match =~ m/^#(\d+)$/ || $match =~ m/^#x[\dA-F]+$/i) {
-                $self->gripe( 'text-unclosed-entity', entity => "&$match;" );
-            } else {
-                $self->gripe( 'text-unknown-entity', entity => "&$match" );
+                $self->gripe( $type . '-unclosed-entity', entity => "&$match;" );
             }
-        } elsif ( $match =~ m/^#(\d+);$/ ) {
-            if ( $1 > 65536 ) {
-                $self->gripe( 'text-invalid-entity', entity => "&$match" );
-            }
-        } elsif ( $match =~ m/^#x([\dA-F]+);$/i ) {
-            if ( length($1) > 4 ) {
-                $self->gripe( 'text-invalid-entity', entity => "&$match" );
+            else {
+                $self->gripe( $type . '-unknown-entity', entity => "&$match" );
             }
-        } else {
+        }
+        elsif ( $match =~ m/^#(\d+);$/ ) {
+            # All numeric entities are OK.  We used to check that they were in a given range.
+        }
+        elsif ( $match =~ m/^#x([\dA-F]+);$/i ) {
+            # All hex entities OK.  We used to check that they were in a given range.
+        }
+        else {
             $match =~ s/;$//;
-            unless ( exists $self->{_entity_lookup}->{$match} ) {
-                $self->gripe( 'text-unknown-entity', entity => "&$match;" );
+            if ( !exists $self->{_entity_lookup}->{$match} ) {
+                $self->gripe( $type . '-unknown-entity', entity => "&$match;" );
             }
         }
     }
@@ -269,8 +282,8 @@ sub _normalize_value {
     my $what = shift;
 
     $what = _trim( $what );
-    return 1 if $what =~ /^(?:1|on|true)$/;
-    return 0 if $what =~ /^(?:0|off|false)$/;
+    return 1 if $what eq '1' || $what eq 'on'  || $what eq 'true';
+    return 0 if $what eq '0' || $what eq 'off' || $what eq 'false';
     return undef;
 }
 
@@ -281,7 +294,7 @@ sub _trim {
     return $_[0];
 }
 
-sub _end {
+sub _end {  ## no critic ( Subroutines::ProhibitManyArgs ) I have no choice in what these args are.
     my ($self,$tag,$line,$column,$tokenpos,@attr) = @_;
 
     $self->{_line} = $line;
@@ -364,7 +377,7 @@ sub _in_context {
 }
 
 # Overridden tag-specific stuff
-sub _start_img {
+sub _start_img {    ## no critic ( Subroutines::ProhibitUnusedPrivateSubroutines )  # Called by parser based on tag name.
     my ($self,$tag,%attr) = @_;
 
     my ($h,$w,$src) = @attr{qw( height width src )};
@@ -381,7 +394,7 @@ sub _start_img {
     return;
 }
 
-sub _start_input {
+sub _start_input {  ## no critic ( Subroutines::ProhibitUnusedPrivateSubroutines )  # Called by parser based on tag name.
     my ($self,$tag,%attr) = @_;
 
     my ($type,$alt) = @attr{qw( type alt )};
diff -pruN 2.26+dfsg-1/lib/HTML/Lint.pm 2.30+dfsg-1/lib/HTML/Lint.pm
--- 2.26+dfsg-1/lib/HTML/Lint.pm	2016-12-30 04:37:39.000000000 +0000
+++ 2.30+dfsg-1/lib/HTML/Lint.pm	2018-01-08 04:10:42.000000000 +0000
@@ -14,11 +14,11 @@ HTML::Lint - check for HTML errors in a
 
 =head1 VERSION
 
-Version 2.26
+Version 2.30
 
 =cut
 
-our $VERSION = '2.26';
+our $VERSION = '2.30';
 
 =head1 SYNOPSIS
 
@@ -149,7 +149,13 @@ See L<HTML::Parser>'s C<parse_file> meth
 
 sub parse_file {
     my $self = shift;
-    return $self->parser->parse_file( @_ );
+
+    my $rc = $self->parser->parse_file( @_ );
+
+    $self->{_parse_called} = 1;
+    $self->eof;
+
+    return $rc;
 }
 
 =head2 $lint->eof()
@@ -162,7 +168,7 @@ HTML::Parser's eof() method.
 
 =cut
 
-sub eof {
+sub eof {   ## no critic ( Subroutines::ProhibitBuiltinHomonyms )
     my $self = shift;
 
     my $rc;
@@ -332,7 +338,7 @@ If you want to turn off all HTML::Lint w
 
 And turn them back on with
 
-    <!-- html-lint all: off -->
+    <!-- html-lint all: on -->
 
 You don't have to use "on" and "off".  For "on", you can use "true"
 or "1".  For "off", you can use "0" or "false".
@@ -358,8 +364,6 @@ DO NOT send bug reports to http://rt.cpa
 
 =item * Form fields that aren't in a FORM
 
-=item * Check for valid entities, and that they end with semicolons
-
 =item * DIVs with nothing in them.
 
 =item * HEIGHT= that have percents in them.
@@ -372,7 +376,7 @@ DO NOT send bug reports to http://rt.cpa
 
 =head1 COPYRIGHT & LICENSE
 
-Copyright 2005-2016 Andy Lester.
+Copyright 2005-2018 Andy Lester.
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the Artistic License v2.0.
diff -pruN 2.26+dfsg-1/lib/Test/HTML/Lint.pm 2.30+dfsg-1/lib/Test/HTML/Lint.pm
--- 2.26+dfsg-1/lib/Test/HTML/Lint.pm	2016-12-30 04:37:51.000000000 +0000
+++ 2.30+dfsg-1/lib/Test/HTML/Lint.pm	2018-01-08 04:11:29.000000000 +0000
@@ -18,11 +18,11 @@ Test::HTML::Lint - Test::More-style wrap
 
 =head1 VERSION
 
-Version 2.26
+Version 2.30
 
 =cut
 
-$VERSION = '2.26';
+$VERSION = '2.30';
 
 my $Tester = Test::Builder->new;
 
@@ -200,7 +200,7 @@ All bugs and requests are now being hand
 
     https://github.com/petdance/html-lint/issues
 
-DO NOT send bug reports to http://rt.cpan.org/ or http://code.google.com/
+DO NOT send bug reports to http://rt.cpan.org/.
 
 
 =head1 TO DO
@@ -222,7 +222,7 @@ this module is taken.
 
 =head1 COPYRIGHT & LICENSE
 
-Copyright 2005-2016 Andy Lester.
+Copyright 2005-2018 Andy Lester.
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the Artistic License v2.0.
diff -pruN 2.26+dfsg-1/Makefile.PL 2.30+dfsg-1/Makefile.PL
--- 2.26+dfsg-1/Makefile.PL	2016-12-30 04:35:37.000000000 +0000
+++ 2.30+dfsg-1/Makefile.PL	2017-12-27 17:49:16.000000000 +0000
@@ -19,6 +19,7 @@ my %parms = (
     ABSTRACT_FROM   => 'lib/HTML/Lint.pm',
     PMLIBDIRS       => [qw(lib/)],
     AUTHOR          => 'Andy Lester <andy@petdance.com>',
+    MIN_PERL_VERSION=> 5.006,
     PREREQ_PM       => {
         'Exporter'              => 0,
         'Test::More'            => 0,
@@ -49,13 +50,13 @@ if ( $ExtUtils::MakeMaker::VERSION ge '6
             bugtracker => 'https://github.com/petdance/html-lint/issues',
             license    => 'http://www.opensource.org/licenses/artistic-license-2.0.php',
             repository => 'https://github.com/petdance/html-lint',
-        }
+        },
     };
 }
 
 WriteMakefile( %parms );
 
-sub MY::postamble {
+sub MY::postamble { ## no critic ( Subroutines::ProhibitQualifiedSubDeclarations )
     my $postamble = <<'MAKE_FRAG';
 
 .PHONY: tags critic
@@ -68,7 +69,7 @@ tags:
 		--languages=Perl --langmap=Perl:+.t \
 
 critic:
-	perlcritic -1 -q -profile perlcriticrc lib/ bin/weblint Makefile.PL
+	perlcritic -1 -q -profile perlcriticrc $(ack -f --perl)
 
 PROF_ARGS = -Mblib blib/script/weblint index.html
 
diff -pruN 2.26+dfsg-1/MANIFEST 2.30+dfsg-1/MANIFEST
--- 2.26+dfsg-1/MANIFEST	2016-12-30 04:38:39.000000000 +0000
+++ 2.30+dfsg-1/MANIFEST	2018-01-08 04:13:11.000000000 +0000
@@ -1,14 +1,13 @@
 Changes
 MANIFEST
 Makefile.PL
-README
+README.md
 bin/weblint
 lib/HTML/Lint.pm
 lib/HTML/Lint/Error.pm
 lib/HTML/Lint/HTML4.pm
 lib/HTML/Lint/Parser.pm
 lib/Test/HTML/Lint.pm
-t/LintTest.pl
 t/00-load.t
 t/01-coverage.t
 t/02-versions.t
@@ -22,10 +21,15 @@ t/30-test-builder.t
 t/40-where.t
 t/50-multiple-files.t
 t/60-add-tags.t
+t/Util.pm
 t/api-eof-not-called.t
 t/api-parse-not-called.t
+t/attr-invalid-entity.t
 t/attr-repeated.t
+t/attr-unclosed-entity.t
+t/attr-unknown-entity.t
 t/attr-unknown.t
+t/attr-use-entity.t
 t/config-unknown-directive.t
 t/config-unknown-value.t
 t/doc-tag-required.t
@@ -38,6 +42,8 @@ t/elem-unclosed.t
 t/elem-unknown.t
 t/elem-unopened.t
 t/embed-extensions.t
+t/nolint.t
+t/parse_file.t
 t/pod-coverage.t
 t/pod.t
 t/random-nobr.t
diff -pruN 2.26+dfsg-1/META.json 2.30+dfsg-1/META.json
--- 2.26+dfsg-1/META.json	2016-12-30 04:38:39.000000000 +0000
+++ 2.30+dfsg-1/META.json	2018-01-08 04:13:11.000000000 +0000
@@ -4,7 +4,7 @@
       "Andy Lester <andy@petdance.com>"
    ],
    "dynamic_config" : 1,
-   "generated_by" : "ExtUtils::MakeMaker version 7.24, CPAN::Meta::Converter version 2.150005",
+   "generated_by" : "ExtUtils::MakeMaker version 7.24, CPAN::Meta::Converter version 2.150010",
    "license" : [
       "artistic_2"
    ],
@@ -39,7 +39,8 @@
             "HTML::Tagset" : "3.03",
             "Test::Builder" : "0",
             "Test::Builder::Tester" : "0",
-            "Test::More" : "0"
+            "Test::More" : "0",
+            "perl" : "5.006"
          }
       }
    },
@@ -56,6 +57,6 @@
          "url" : "https://github.com/petdance/html-lint"
       }
    },
-   "version" : "2.26",
-   "x_serialization_backend" : "JSON::PP version 2.27300"
+   "version" : "2.30",
+   "x_serialization_backend" : "JSON::PP version 2.27400_02"
 }
diff -pruN 2.26+dfsg-1/META.yml 2.30+dfsg-1/META.yml
--- 2.26+dfsg-1/META.yml	2016-12-30 04:38:39.000000000 +0000
+++ 2.30+dfsg-1/META.yml	2018-01-08 04:13:11.000000000 +0000
@@ -7,7 +7,7 @@ build_requires:
 configure_requires:
   ExtUtils::MakeMaker: '0'
 dynamic_config: 1
-generated_by: 'ExtUtils::MakeMaker version 7.24, CPAN::Meta::Converter version 2.150005'
+generated_by: 'ExtUtils::MakeMaker version 7.24, CPAN::Meta::Converter version 2.150010'
 license: artistic_2
 meta-spec:
   url: http://module-build.sourceforge.net/META-spec-v1.4.html
@@ -26,10 +26,11 @@ requires:
   Test::Builder: '0'
   Test::Builder::Tester: '0'
   Test::More: '0'
+  perl: '5.006'
 resources:
   bugtracker: https://github.com/petdance/html-lint/issues
   homepage: http://search.cpan.org/dist/html-lint
   license: http://www.opensource.org/licenses/artistic-license-2.0.php
   repository: https://github.com/petdance/html-lint
-version: '2.26'
+version: '2.30'
 x_serialization_backend: 'CPAN::Meta::YAML version 0.018'
diff -pruN 2.26+dfsg-1/README 2.30+dfsg-1/README
--- 2.26+dfsg-1/README	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-HTML::Lint is a pure-Perl HTML parser and checker for syntactic legitmacy.
-It supports only HTML 4.
-
-The "weblint" program that comes with HTML::Lint lets you lint a webpage
-or local files.
-
-For those of you doing automated testing with Test::More and the rest
-of the Perl testing framework, Test::HTML::Lint lets you automate HTML
-checking.
-
-Andy Lester
-andy at petdance.com
diff -pruN 2.26+dfsg-1/README.md 2.30+dfsg-1/README.md
--- 2.26+dfsg-1/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/README.md	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,18 @@
+# HTML::Lint
+
+* Linux [![Build Status](https://api.travis-ci.org/petdance/html-lint.svg?branch=dev)](https://travis-ci.org/petdance/html-lint)
+* [CPAN Testers](http://cpantesters.org/distro/H/html-lint.html)
+
+HTML::Lint is a pure-Perl HTML parser and checker for syntactic legitmacy.
+It supports only HTML 4.
+
+The "weblint" program that comes with HTML::Lint lets you lint a webpage
+or local files.
+
+For those of you doing automated testing with Test::More and the rest
+of the Perl testing framework, Test::HTML::Lint lets you automate HTML
+checking.
+
+Andy Lester
+
+andy at petdance dot com
diff -pruN 2.26+dfsg-1/t/00-load.t 2.30+dfsg-1/t/00-load.t
--- 2.26+dfsg-1/t/00-load.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/00-load.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,13 +1,12 @@
 #!perl -Tw
 
-use Test::More tests => 2;
+use strict;
+use warnings;
 
-BEGIN {
-    use_ok( 'HTML::Lint' );
-}
+use Test::More tests => 1;
 
-BEGIN {
-    use_ok( 'Test::HTML::Lint' );
-}
+use HTML::Lint;
+use Test::HTML::Lint;
 
+pass( 'Loaded modules' );
 diag( "Testing HTML::Lint $HTML::Lint::VERSION, Perl $], $^X" );
diff -pruN 2.26+dfsg-1/t/01-coverage.t 2.30+dfsg-1/t/01-coverage.t
--- 2.26+dfsg-1/t/01-coverage.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/01-coverage.t	2017-12-27 17:49:16.000000000 +0000
@@ -2,13 +2,14 @@
 
 # This test verifies that there is a t/*.t file for every possible Lint error.
 
+use strict;
+use warnings;
+
 use Test::More 'no_plan';
 
-BEGIN {
-    use_ok( 'HTML::Lint::Error' );
-}
+use HTML::Lint::Error;
 
-my @errors = do { no warnings; keys %HTML::Lint::Error::errors };
+my @errors = keys %HTML::Lint::Error::errors;
 
 isnt( scalar @errors, 0, 'There are at least some errors to be found.' );
 
diff -pruN 2.26+dfsg-1/t/02-versions.t 2.30+dfsg-1/t/02-versions.t
--- 2.26+dfsg-1/t/02-versions.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/02-versions.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,17 +3,11 @@
 use warnings;
 use strict;
 
-use Test::More tests => 5;
+use Test::More tests => 2;
 
-BEGIN {
-    use_ok( 'HTML::Lint::Parser' );
-}
-BEGIN {
-    use_ok( 'HTML::Lint' );
-}
-BEGIN {
-    use_ok( 'Test::HTML::Lint' );
-}
+use HTML::Lint::Parser;
+use HTML::Lint;
+use Test::HTML::Lint;
 
 is( $HTML::Lint::VERSION, $Test::HTML::Lint::VERSION, 'HTML::Lint and Test::HTML::Lint versions match' );
 is( $HTML::Lint::VERSION, $HTML::Lint::Parser::VERSION, 'HTML::Lint and Test::HTML::Lint versions match' );
diff -pruN 2.26+dfsg-1/t/10-test-html-lint.t 2.30+dfsg-1/t/10-test-html-lint.t
--- 2.26+dfsg-1/t/10-test-html-lint.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/10-test-html-lint.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,17 +3,13 @@
 use warnings;
 use strict;
 
-use Test::More tests => 3;
+use Test::More tests => 2;
 use Test::HTML::Lint;
 
-BEGIN {
-    use_ok( 'Test::HTML::Lint' );
-}
-
 my $chunk = '<html><head></head><body><title>A fine chunk of code</title></body></html>';
 
 TODO: { # undef should fail
-    local $TODO = "This test should NOT succeed";
+    local $TODO = 'This test should NOT succeed';
     html_ok( undef );
 }
 html_ok( $chunk );
diff -pruN 2.26+dfsg-1/t/11-test-html-lint-overload.t 2.30+dfsg-1/t/11-test-html-lint-overload.t
--- 2.26+dfsg-1/t/11-test-html-lint-overload.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/11-test-html-lint-overload.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,11 +3,12 @@
 use strict;
 use warnings;
 
-use Test::More tests => 4;
+use Test::More tests => 1;
+
+use HTML::Lint;
+use HTML::Lint::Error;
+use Test::HTML::Lint;
 
-BEGIN { use_ok( 'Test::HTML::Lint' ); }
-BEGIN { use_ok( 'HTML::Lint' ); }
-BEGIN { use_ok( 'HTML::Lint::Error' ); }
 
 my $lint = HTML::Lint->new();
 $lint->only_types( HTML::Lint::Error::FLUFF );
diff -pruN 2.26+dfsg-1/t/12-html_fragment_ok.t 2.30+dfsg-1/t/12-html_fragment_ok.t
--- 2.26+dfsg-1/t/12-html_fragment_ok.t	2016-12-30 04:35:37.000000000 +0000
+++ 2.30+dfsg-1/t/12-html_fragment_ok.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,3 +1,5 @@
+#!perl
+
 use warnings;
 use strict;
 
diff -pruN 2.26+dfsg-1/t/20-error-types-export.t 2.30+dfsg-1/t/20-error-types-export.t
--- 2.26+dfsg-1/t/20-error-types-export.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/20-error-types-export.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,9 +3,9 @@
 use warnings;
 use strict;
 
-use Test::More tests => 5;
+use Test::More tests => 4;
 
-BEGIN { use_ok( 'HTML::Lint::Error', ':types' ); }
+use HTML::Lint::Error ':types';
 
 my $err = HTML::Lint::Error->new( undef, undef, undef, 'elem-empty-but-closed' );
 
diff -pruN 2.26+dfsg-1/t/20-error-types-skip.t 2.30+dfsg-1/t/20-error-types-skip.t
--- 2.26+dfsg-1/t/20-error-types-skip.t	2016-12-24 04:39:20.000000000 +0000
+++ 2.30+dfsg-1/t/20-error-types-skip.t	2017-12-27 17:49:16.000000000 +0000
@@ -2,10 +2,10 @@
 
 use strict;
 use warnings;
-use Test::More tests => 10;
+use Test::More tests => 8;
 
-BEGIN { use_ok( 'HTML::Lint' ); }
-BEGIN { use_ok( 'HTML::Lint::Error', ':types' ); }
+use HTML::Lint;
+use HTML::Lint::Error ':types';
 
 my $text = do { local $/ = undef; <DATA> };
 
diff -pruN 2.26+dfsg-1/t/20-error-types.t 2.30+dfsg-1/t/20-error-types.t
--- 2.26+dfsg-1/t/20-error-types.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/20-error-types.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,9 +3,9 @@
 use warnings;
 use strict;
 
-use Test::More tests => 5;
+use Test::More tests => 4;
 
-BEGIN { use_ok( 'HTML::Lint::Error' ); }
+use HTML::Lint::Error;
 
 my $err = HTML::Lint::Error->new( undef, undef, undef, 'elem-empty-but-closed' );
 
diff -pruN 2.26+dfsg-1/t/40-where.t 2.30+dfsg-1/t/40-where.t
--- 2.26+dfsg-1/t/40-where.t	2016-12-24 04:39:20.000000000 +0000
+++ 2.30+dfsg-1/t/40-where.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use strict;
 use warnings;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 my $html = '</body>';
 
diff -pruN 2.26+dfsg-1/t/50-multiple-files.t 2.30+dfsg-1/t/50-multiple-files.t
--- 2.26+dfsg-1/t/50-multiple-files.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/50-multiple-files.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,46 +1,66 @@
+#!perl
+
 use warnings;
 use strict;
 
-require 't/LintTest.pl';
+use lib 't/';
+use Util;
 
-my @files = get_paragraphed_files();
+my @files = _get_paragraphed_files();
 
 checkit( [
     [ 'elem-unopened' => qr/<\/p> with no opening <P>/i ],
 
-    [ 'elem-unclosed' => qr/<b> at \(6:5\) is never closed/i ],
-    [ 'elem-unclosed' => qr/<i> at \(7:5\) is never closed/i ],
+    [ 'elem-unclosed' => qr/\Q<b> at (6:12) is never closed/i ],
+    [ 'elem-unclosed' => qr/\Q<i> at (7:12) is never closed/i ],
 
     [ 'elem-unopened' => qr/<\/b> with no opening <B>/i ],
 ], @files );
 
+# Read in a set of sets of lines, where each "file" is separated by a
+# blank line in <DATA>
+sub _get_paragraphed_files {
+    local $/ = '';
+
+    my @sets;
+
+    while ( my $paragraph = <DATA> ) {
+        my @lines = split /\n/, $paragraph;
+        @lines = map { "$_\n" } @lines;
+        push( @sets, [@lines] );
+    }
+
+    return @sets;
+}
+
+
 __DATA__
 <HTML> <!-- for elem-unopened -->
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	This is my paragraph</P>
+        This is my paragraph</P>
     </BODY>
 </HTML>
 
 <HTML>
     <HEAD> <!-- Checking for elem-unclosed -->
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P><B>This is my paragraph</P>
-	<P><I>This is another paragraph</P>
+        <P><B>This is my paragraph</P>
+        <P><I>This is another paragraph</P>
     </BODY>
 </HTML>
 
 <!-- based on doc-tag-required -->
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
         </B>Gratuitous unnecessary closing tag that does NOT match to the opening [B] above.
-	<P>This is my paragraph</P>
+        <P>This is my paragraph</P>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/60-add-tags.t 2.30+dfsg-1/t/60-add-tags.t
--- 2.26+dfsg-1/t/60-add-tags.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/60-add-tags.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,7 +3,8 @@
 use warnings;
 use strict;
 
-require 't/LintTest.pl';
+use lib 't/';
+use Util;
 
 use HTML::Lint::HTML4;
 
diff -pruN 2.26+dfsg-1/t/attr-invalid-entity.t 2.30+dfsg-1/t/attr-invalid-entity.t
--- 2.26+dfsg-1/t/attr-invalid-entity.t	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/attr-invalid-entity.t	2018-01-08 04:09:01.000000000 +0000
@@ -0,0 +1,23 @@
+#!perl
+
+use warnings;
+use strict;
+
+use lib 't/';
+use Util;
+
+
+# We used to have attr-invalid-entity if the entities had an invalid value, but we no longer do.
+
+checkit( [
+], [<DATA>] );
+
+__DATA__
+<HTML>
+    <HEAD>
+        <TITLE>Test stuff</TITLE>
+    </HEAD>
+    <BODY BGCOLOR="Testing invalid entity &#8675309;">
+    <p style="color: &#xdeadbeef;"></p>
+    </BODY>
+</HTML>
diff -pruN 2.26+dfsg-1/t/attr-repeated.t 2.30+dfsg-1/t/attr-repeated.t
--- 2.26+dfsg-1/t/attr-repeated.t	2016-12-24 03:30:41.000000000 +0000
+++ 2.30+dfsg-1/t/attr-repeated.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,17 +1,21 @@
+#!perl
+
 use strict;
 use warnings;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'attr-repeated' => qr/ALIGN attribute in <P> is repeated/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P ALIGN=LEFT ALIGN=RIGHT>This is my paragraph</P>
+        <P ALIGN=LEFT ALIGN=RIGHT>This is my paragraph</P>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/attr-unclosed-entity.t 2.30+dfsg-1/t/attr-unclosed-entity.t
--- 2.26+dfsg-1/t/attr-unclosed-entity.t	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/attr-unclosed-entity.t	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,23 @@
+#!perl
+
+use warnings;
+use strict;
+
+use lib 't/';
+use Util;
+
+checkit( [
+    [ 'attr-unclosed-entity' => qr/Entity &#63; is missing its closing semicolon/ ],
+    [ 'attr-unclosed-entity' => qr/Entity &ouml; is missing its closing semicolon/ ],
+], [<DATA>] );
+
+__DATA__
+<HTML>
+    <HEAD>
+        <TITLE>Test stuff</TITLE>
+    </HEAD>
+    <BODY BGCOLOR="Unclosed entity at end of attr &#63">
+    <a href="http://imotorhead.com/" title="Mot&ouml rhead rulez!">Mot&ouml;rhead</a>
+    <a href="http://imotorhead.com/" title="Mot&ouml; rhead rulez!">Mot&ouml;rhead</a>
+    </BODY>
+</HTML>
diff -pruN 2.26+dfsg-1/t/attr-unknown-entity.t 2.30+dfsg-1/t/attr-unknown-entity.t
--- 2.26+dfsg-1/t/attr-unknown-entity.t	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/attr-unknown-entity.t	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,20 @@
+#!perl
+
+use warnings;
+use strict;
+
+use lib 't/';
+use Util;
+
+checkit( [
+    [ 'attr-unknown-entity' => qr/Entity &numsefisk; is unknown/ ],
+], [<DATA>] );
+
+__DATA__
+<HTML>
+    <HEAD>
+        <TITLE>Test stuff</TITLE>
+    </HEAD>
+    <BODY BGCOLOR="Testing unknown entity &numsefisk;">
+    </BODY>
+</HTML>
diff -pruN 2.26+dfsg-1/t/attr-unknown.t 2.30+dfsg-1/t/attr-unknown.t
--- 2.26+dfsg-1/t/attr-unknown.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/attr-unknown.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,19 +1,23 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'attr-unknown' => qr/Unknown attribute "FOOD" for tag <P>/i ],
     [ 'attr-unknown' => qr/Unknown attribute "Yummy" for tag <I>/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P FOOD="Burrito" ALIGN=RIGHT>This is my paragraph about burritos</P>
-	<I YUMMY="Spanish Rice">This is my paragraph about refried beans</I>
+        <P FOOD="Burrito" ALIGN=RIGHT>This is my paragraph about burritos</P>
+        <I YUMMY="Spanish Rice">This is my paragraph about refried beans</I>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/attr-use-entity.t 2.30+dfsg-1/t/attr-use-entity.t
--- 2.26+dfsg-1/t/attr-use-entity.t	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/attr-use-entity.t	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,24 @@
+#!perl
+
+use warnings;
+use strict;
+
+use lib 't/';
+use Util;
+
+checkit( [
+    [ 'attr-use-entity'      => qr/Character "\\xF1" should be written as &ntilde;/ ],
+    [ 'attr-use-entity'      => qr/Character "&" should be written as &amp;/ ],
+    [ 'attr-use-entity'      => qr/Character "&" should be written as &amp;/ ],
+
+], [<DATA>] );
+
+__DATA__
+<HTML>
+    <HEAD>
+        <TITLE>Test stuff</TITLE>
+    </HEAD>
+    <BODY BGCOLOR="We'll get to it maana, which should really have an &ntilde;">
+    <a href="#" title="Who wants a peanut butter & jelly?  Mot&ouml;rhead does!  They love rock & roll"></a>
+    </BODY>
+</HTML>
diff -pruN 2.26+dfsg-1/t/config-unknown-directive.t 2.30+dfsg-1/t/config-unknown-directive.t
--- 2.26+dfsg-1/t/config-unknown-directive.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/config-unknown-directive.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     # [ 'config-unknown-directive' => q{Set #1 (6:5) Unknown directive "bongo"} ],
diff -pruN 2.26+dfsg-1/t/config-unknown-value.t 2.30+dfsg-1/t/config-unknown-value.t
--- 2.26+dfsg-1/t/config-unknown-value.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/config-unknown-value.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'config-unknown-value' => qr/Unknown value "14" for elem-img-sizes-missing directive$/ ],
diff -pruN 2.26+dfsg-1/t/doc-tag-required.t 2.30+dfsg-1/t/doc-tag-required.t
--- 2.26+dfsg-1/t/doc-tag-required.t	2016-12-17 03:51:14.000000000 +0000
+++ 2.30+dfsg-1/t/doc-tag-required.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'doc-tag-required' => qr/<html> tag is required/ ],
@@ -9,8 +13,8 @@ checkit( [
 __DATA__
 <!-- doc-tag-required -->
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P>This is my paragraph</P>
+        <P>This is my paragraph</P>
     </BODY>
diff -pruN 2.26+dfsg-1/t/elem-empty-but-closed.t 2.30+dfsg-1/t/elem-empty-but-closed.t
--- 2.26+dfsg-1/t/elem-empty-but-closed.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-empty-but-closed.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,17 +1,21 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-empty-but-closed' => qr/<hr> is not a container -- <\/hr> is not allowed/ ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<HR>This is a bad paragraph</HR>
+        <HR>This is a bad paragraph</HR>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/elem-img-alt-missing.t 2.30+dfsg-1/t/elem-img-alt-missing.t
--- 2.26+dfsg-1/t/elem-img-alt-missing.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-img-alt-missing.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,18 +1,22 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-img-alt-missing' => qr/<IMG SRC="whizbang\.jpg"> does not have ALT text defined/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P ALIGN=RIGHT>This is my paragraph</P>
-	<IMG SRC="whizbang.jpg" BORDER=3 HEIGHT=4 WIDTH=921 />
+        <P ALIGN=RIGHT>This is my paragraph</P>
+        <IMG SRC="whizbang.jpg" BORDER=3 HEIGHT=4 WIDTH=921 />
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/elem-img-sizes-missing.t 2.30+dfsg-1/t/elem-img-sizes-missing.t
--- 2.26+dfsg-1/t/elem-img-sizes-missing.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-img-sizes-missing.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-img-sizes-missing' => qr/\Q<IMG SRC="swedish-schwern.jpg"> tag has no HEIGHT and WIDTH attributes/i ],
@@ -10,11 +14,11 @@ checkit( [
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P ALIGN=RIGHT>This is my paragraph</P>
-	<IMG BORDER=3 HSPACE=12 SRC="swedish-schwern.jpg" ALT="Bork! Bork! Bork!" />
-	<IMG BORDER="3" HSPACE="12" SRC="bongo-bongo.jpg" ALT="">
+        <P ALIGN=RIGHT>This is my paragraph</P>
+        <IMG BORDER=3 HSPACE=12 SRC="swedish-schwern.jpg" ALT="Bork! Bork! Bork!" />
+        <IMG BORDER="3" HSPACE="12" SRC="bongo-bongo.jpg" ALT="">
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/elem-input-alt-missing.t 2.30+dfsg-1/t/elem-input-alt-missing.t
--- 2.26+dfsg-1/t/elem-input-alt-missing.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-input-alt-missing.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-input-alt-missing' => qr/<input name="dave" type="image"> does not have non-blank ALT text defined/i ],
diff -pruN 2.26+dfsg-1/t/elem-nonrepeatable.t 2.30+dfsg-1/t/elem-nonrepeatable.t
--- 2.26+dfsg-1/t/elem-nonrepeatable.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-nonrepeatable.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,18 +1,22 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
-    [ 'elem-nonrepeatable' => qr/<title> is not repeatable, but already appeared at \(3:2\)/i ],
+    [ 'elem-nonrepeatable' => qr/\Q<title> is not repeatable, but already appeared at (3:9)/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
-	<TITLE>As if one title isn't enough</TITLE>
+        <TITLE>Test stuff</TITLE>
+        <TITLE>As if one title isn't enough</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P>This is my paragraph</P>
+        <P>This is my paragraph</P>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/elem-unclosed.t 2.30+dfsg-1/t/elem-unclosed.t
--- 2.26+dfsg-1/t/elem-unclosed.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-unclosed.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,19 +1,23 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
-    [ 'elem-unclosed' => qr/\Q<b> at (6:5) is never closed/i ],
-    [ 'elem-unclosed' => qr/\Q<i> at (7:5) is never closed/i ],
+    [ 'elem-unclosed' => qr/\Q<b> at (6:12) is never closed/i ],
+    [ 'elem-unclosed' => qr/\Q<i> at (7:12) is never closed/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD> <!-- Checking for elem-unclosed -->
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P><B>This is my paragraph</P>
-	<P><I>This is another paragraph</P>
+        <P><B>This is my paragraph</P>
+        <P><I>This is another paragraph</P>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/elem-unknown.t 2.30+dfsg-1/t/elem-unknown.t
--- 2.26+dfsg-1/t/elem-unknown.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-unknown.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,20 +1,24 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-unknown' => qr/unknown element <donky>/i ],
     [ 'elem-unclosed' => qr/<donky> at \(\d+:\d+\) is never closed/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<P ALIGN=RIGHT>This is my paragraph</P>
-	<DONKY>
-	<IMG SRC="http://www.petdance.com/random/whizbang.jpg" BORDER=3 HEIGHT=4 WIDTH=921 ALT="whizbang!">
+        <P ALIGN=RIGHT>This is my paragraph</P>
+        <DONKY>
+        <IMG SRC="http://www.petdance.com/random/whizbang.jpg" BORDER=3 HEIGHT=4 WIDTH=921 ALT="whizbang!">
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/elem-unopened.t 2.30+dfsg-1/t/elem-unopened.t
--- 2.26+dfsg-1/t/elem-unopened.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/elem-unopened.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-unopened' => qr/<\/p> with no opening <P>/i ],
@@ -9,9 +13,9 @@ checkit( [
 __DATA__
 <HTML> <!-- for elem-unopened -->
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	This is my paragraph</P>
+        This is my paragraph</P>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/LintTest.pl 2.30+dfsg-1/t/LintTest.pl
--- 2.26+dfsg-1/t/LintTest.pl	2016-12-17 03:56:33.000000000 +0000
+++ 2.30+dfsg-1/t/LintTest.pl	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-use Test::More;
-use HTML::Lint;
-
-sub checkit {
-    my @expected = @{+shift};
-    my @linesets = @_;
-
-    plan( tests => 3*(scalar @expected) + 4 );
-
-    my $lint = new HTML::Lint;
-    isa_ok( $lint, 'HTML::Lint', 'Created lint object' );
-
-    my $n;
-    for my $set ( @linesets ) {
-        ++$n;
-        $lint->newfile( "Set #$n" );
-        $lint->parse( $_ ) for @$set;
-        $lint->eof;
-    }
-
-    my @errors = $lint->errors();
-    is( scalar @errors, scalar @expected, 'Right # of errors' );
-
-    while ( @errors && @expected ) {
-        my $error = shift @errors;
-        isa_ok( $error, 'HTML::Lint::Error' );
-
-        my $expected = shift @expected;
-
-        is( $error->errcode, $expected->[0], 'Error codes match' );
-        my $match = $expected->[1];
-        if ( ref $match eq "Regexp" ) {
-            like( $error->as_string, $match, 'Error matches regex' );
-        }
-        else {
-            is( $error->as_string, $match, 'Error matches string' );
-        }
-    }
-
-    my $dump;
-
-    is( scalar @errors, 0, 'No unexpected errors found' ) or $dump = 1;
-    is( scalar @expected, 0, 'No expected errors missing' ) or $dump = 1;
-
-    if ( $dump && @errors ) {
-        diag( "Leftover errors..." ); 
-        diag( $_->as_string ) for @errors;
-    }
-}
-
-# Read in a set of sets of lines, where each "file" is separated by a
-# blank line in <DATA>
-sub get_paragraphed_files {
-    local $/ = "";
-
-    my @sets;
-
-    while ( my $paragraph = <DATA> ) {
-        my @lines = split /\n/, $paragraph;
-        @lines = map { "$_\n" } @lines;
-        push( @sets, [@lines] );
-    }
-
-    return @sets;
-}
-
-1; # happy
diff -pruN 2.26+dfsg-1/t/nolint.t 2.30+dfsg-1/t/nolint.t
--- 2.26+dfsg-1/t/nolint.t	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/nolint.t	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,45 @@
+#!perl
+
+use warnings;
+use strict;
+
+use lib 't/';
+use Util;
+
+checkit( [
+    [ 'elem-img-sizes-missing' => qr/\Q<img src="alpha.jpg"> tag has no HEIGHT and WIDTH attributes/i ],
+    [ 'elem-img-alt-missing'   => qr/\Q<img src="alpha.jpg"> does not have ALT text defined/i ],
+
+    [ 'elem-img-alt-missing'   => qr/\Q<img src="beta.jpg"> does not have ALT text defined/i ],
+
+    # gamma.jpg will not error at all
+
+    [ 'elem-img-alt-missing'   => qr/\Q<img src="delta.jpg"> does not have ALT text defined/i ],
+
+    [ 'elem-img-sizes-missing' => qr/\Q<img src="epsilon.jpg"> tag has no HEIGHT and WIDTH attributes/i ],
+    [ 'elem-img-alt-missing'   => qr/\Q<img src="epsilon.jpg"> does not have ALT text defined/i ],
+    [ 'elem-unclosed'          => 'Set #1 (20:5) <gooble> at (13:9) is never closed' ],
+], [<DATA>] );
+
+__DATA__
+<html>
+    <head>
+        <title>Test stuff</title>
+    </head>
+    <body bgcolor="white">
+        <img src="alpha.jpg">
+
+        <!-- html-lint elem-img-sizes-missing: off, attr-unknown: off -->
+        <img src="beta.jpg" />
+
+        <!-- html-lint all: off -->
+        <img src="gamma.jpg" />
+        <gooble darble="fungo" />
+
+        <!-- html-lint elem-img-alt-missing: on -->
+        <img src="delta.jpg">
+
+        <!-- html-lint all: on -->
+        <img src="epsilon.jpg">
+    </body>
+</html>
diff -pruN 2.26+dfsg-1/t/parse_file.t 2.30+dfsg-1/t/parse_file.t
--- 2.26+dfsg-1/t/parse_file.t	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/parse_file.t	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,31 @@
+#!perl -T
+
+use warnings;
+use strict;
+
+use Test::More tests => 1;
+use HTML::Lint;
+use File::Temp qw( tempfile );
+
+my ($o, $OUTPUT_FN) = tempfile( SUFFIX => '.xhtml', UNLINK => 1);
+print {$o} <<'EOF';
+<?xml version="1.0" encoding="utf-8"?>
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
+<html xml:lang="en-US" xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<title>Foo</title>
+<meta content="text/html; charset=utf-8" http-equiv="Content-Type"/>
+</head>
+<body>
+<h1>Hello</h1>
+<p>File</p>
+</body>
+</html>
+EOF
+close($o) or die $!;
+
+my $lint = HTML::Lint->new;
+
+$lint->parse_file($OUTPUT_FN);
+
+is_deeply( [map { $_->as_string() } $lint->errors()], [], 'HTML is valid for output file.' );
diff -pruN 2.26+dfsg-1/t/pod-coverage.t 2.30+dfsg-1/t/pod-coverage.t
--- 2.26+dfsg-1/t/pod-coverage.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/pod-coverage.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,8 +1,11 @@
 #!perl -Tw
+
 use warnings;
 use strict;
 
 use Test::More;
-eval "use Test::Pod::Coverage 1.04";
-plan skip_all => "Test::Pod::Coverage 1.04 required for testing POD coverage" if $@;
+if ( !eval 'use Test::Pod::Coverage 1.04; 1;' ) {   ## no critic ( BuiltinFunctions::ProhibitStringyEval )
+    plan skip_all => 'Test::Pod::Coverage 1.04 required for testing POD coverage';
+}
+
 all_pod_coverage_ok();
diff -pruN 2.26+dfsg-1/t/pod.t 2.30+dfsg-1/t/pod.t
--- 2.26+dfsg-1/t/pod.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/pod.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,12 @@
 #!perl -Tw
 
+use strict;
+use warnings;
+
 use Test::More;
-eval "use Test::Pod 1.14";
-plan skip_all => "Test::Pod 1.14 required for testing POD" if $@;
+
+if ( !eval 'use Test::Pod 1.14; 1;' ) { ## no critic ( BuiltinFunctions::ProhibitStringyEval )
+    plan skip_all => 'Test::Pod 1.14 required for testing POD';
+}
+
 all_pod_files_ok();
diff -pruN 2.26+dfsg-1/t/random-nobr.t 2.30+dfsg-1/t/random-nobr.t
--- 2.26+dfsg-1/t/random-nobr.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/random-nobr.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,20 +1,24 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'elem-unknown' => qr/unknown element <donky>/i ],
     [ 'elem-unclosed' => qr/<donky> at \(\d+:\d+\) is never closed/i ],
 ], [<DATA>] );
-    
+
 __DATA__
 <HTML>
     <HEAD>
-	<TITLE>Test stuff</TITLE>
+        <TITLE>Test stuff</TITLE>
     </HEAD>
     <BODY BGCOLOR="white">
-	<NOBR>NOBR is fine with me!</NOBR>
-	<DONKY>
-	<NOBR>But Donky is not</NOBR>
+        <NOBR>NOBR is fine with me!</NOBR>
+        <DONKY>
+        <NOBR>But Donky is not</NOBR>
     </BODY>
 </HTML>
diff -pruN 2.26+dfsg-1/t/strong-id.t 2.30+dfsg-1/t/strong-id.t
--- 2.26+dfsg-1/t/strong-id.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/strong-id.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'attr-unknown' => qr/Unknown attribute "bongo" for tag <strong>/ ],
diff -pruN 2.26+dfsg-1/t/text-invalid-entity.t 2.30+dfsg-1/t/text-invalid-entity.t
--- 2.26+dfsg-1/t/text-invalid-entity.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/text-invalid-entity.t	2018-01-08 04:09:01.000000000 +0000
@@ -3,12 +3,12 @@
 use warnings;
 use strict;
 
-require 't/LintTest.pl';
+use lib 't/';
+use Util;
 
+# We used to have text-invalid-entity if the entities had an invalid value, but we no longer do.
 checkit( [
     [ 'text-unknown-entity' => qr/Entity &metalhorns; is unknown/ ],
-    [ 'text-invalid-entity' => qr/Entity &#8675309; is invalid/ ],
-    [ 'text-invalid-entity' => qr/Entity &#xdeadbeef; is invalid/ ],
     [ 'text-unknown-entity' => qr/Entity &xdeadbeef; is unknown/ ],
 ], [<DATA>] );
 
@@ -36,7 +36,7 @@ __DATA__
         <p>
         Another deceased cow: &xdeadbeef; <!-- Not a valid hex entity, but unknown to our lookup tables -->
         <p>
-        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&feature=related">"You Better Swim"</a> from the SpongeBob movie.
+        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&amp;feature=related">"You Better Swim"</a> from the SpongeBob movie.
         <!--
         Here in the safety of comments, we can put whatever &invalid; and &malformed entities we want, &
         nobody can stop us.  Except maybe Cheech & Chong.
diff -pruN 2.26+dfsg-1/t/text-unclosed-entity.t 2.30+dfsg-1/t/text-unclosed-entity.t
--- 2.26+dfsg-1/t/text-unclosed-entity.t	2016-12-07 04:45:48.000000000 +0000
+++ 2.30+dfsg-1/t/text-unclosed-entity.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,7 +3,8 @@
 use warnings;
 use strict;
 
-require 't/LintTest.pl';
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'text-unclosed-entity' => qr/Entity &ouml; is missing its closing semicolon/ ],
@@ -28,7 +29,7 @@ __DATA__
         &sup; &sup2; But can we find an unclosed entity at the end of the line &#63
         <p>
         What about unclosed unknown entities in the &middle of the line?
-        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&feature=related">"You Better Swim"</a> from the SpongeBob movie.
+        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&amp;feature=related">"You Better Swim"</a> from the SpongeBob movie.
         <!--
         Here in the safety of comments, we can put whatever &invalid; and &malformed entities we want, &
         nobody can stop us.  Except maybe Cheech & Chong.
diff -pruN 2.26+dfsg-1/t/text-unknown-entity.t 2.30+dfsg-1/t/text-unknown-entity.t
--- 2.26+dfsg-1/t/text-unknown-entity.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/text-unknown-entity.t	2017-12-27 17:49:16.000000000 +0000
@@ -3,7 +3,8 @@
 use warnings;
 use strict;
 
-require 't/LintTest.pl';
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'text-unknown-entity' => qr/Entity &metalhorns; is unknown/ ],
@@ -17,7 +18,7 @@ __DATA__
     <body bgcolor="white">
         Thanks for visiting Ace of &#9824; <!-- Numeric version of &spades; -->
         <p>
-        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&feature=related">"You Better Swim"</a> from the SpongeBob movie.
+        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&amp;feature=related">"You Better Swim"</a> from the SpongeBob movie.
         <!--
         Here in the safety of comments, we can put whatever &invalid; and &malformed entities we want, &
         nobody can stop us.  Except maybe Cheech & Chong.
diff -pruN 2.26+dfsg-1/t/text-use-entity.t 2.30+dfsg-1/t/text-use-entity.t
--- 2.26+dfsg-1/t/text-use-entity.t	2016-12-08 04:19:55.000000000 +0000
+++ 2.30+dfsg-1/t/text-use-entity.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,7 +1,11 @@
+#!perl
+
 use utf8;
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
     [ 'text-use-entity'      => qr/Character "\\x0B" should be written as &#11;/ ],
@@ -34,7 +38,7 @@ __DATA__
         Who wants a peanut butter & jelly?  Mot&ouml rhead does!  They love rock &
         roll!
         <p>
-        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&feature=related">"You Better Swim"</a> from the SpongeBob movie.
+        Here's an awesome link to <a href="http://www.youtube.com/watch?v=8yLhA0ROGi4&amp;feature=related">"You Better Swim"</a> from the SpongeBob movie.
         <p>
         <!--
         Here in the safety of comments, we can put whatever &invalid; and &malformed entities we want, &
diff -pruN 2.26+dfsg-1/t/Util.pm 2.30+dfsg-1/t/Util.pm
--- 2.26+dfsg-1/t/Util.pm	1970-01-01 00:00:00.000000000 +0000
+++ 2.30+dfsg-1/t/Util.pm	2017-12-27 17:49:16.000000000 +0000
@@ -0,0 +1,64 @@
+package Util;
+
+use parent 'Exporter';
+
+use warnings;
+use strict;
+
+use Test::More;
+use HTML::Lint;
+
+our @EXPORT = qw(
+    checkit
+);
+
+sub checkit {
+    my @expected = @{+shift};
+    my @linesets = @_;
+
+    plan( tests => 3*(scalar @expected) + 4 );
+
+    my $lint = HTML::Lint->new;
+    isa_ok( $lint, 'HTML::Lint', 'Created lint object' );
+
+    my $n;
+    for my $set ( @linesets ) {
+        ++$n;
+        $lint->newfile( "Set #$n" );
+        $lint->parse( $_ ) for @{$set};
+        $lint->eof;
+    }
+
+    my @errors = $lint->errors();
+    is( scalar @errors, scalar @expected, 'Right # of errors' );
+
+    while ( @errors && @expected ) {
+        my $error = shift @errors;
+        isa_ok( $error, 'HTML::Lint::Error' );
+
+        my $expected = shift @expected;
+
+        is( $error->errcode, $expected->[0], 'Error codes match' );
+        my $match = $expected->[1];
+        if ( ref($match) eq 'Regexp' ) {
+            like( $error->as_string, $match, 'Error matches regex' );
+        }
+        else {
+            is( $error->as_string, $match, 'Error matches string' );
+        }
+    }
+
+    my $dump;
+
+    is( scalar @errors, 0, 'No unexpected errors found' ) or $dump = 1;
+    is( scalar @expected, 0, 'No expected errors missing' ) or $dump = 1;
+
+    if ( $dump && @errors ) {
+        diag( 'Leftover errors...' );
+        diag( $_->as_string ) for @errors;
+    }
+
+    return;
+}
+
+1; # happy
diff -pruN 2.26+dfsg-1/t/xhtml-html.t 2.30+dfsg-1/t/xhtml-html.t
--- 2.26+dfsg-1/t/xhtml-html.t	2016-07-09 02:59:33.000000000 +0000
+++ 2.30+dfsg-1/t/xhtml-html.t	2017-12-27 17:49:16.000000000 +0000
@@ -1,6 +1,10 @@
+#!perl
+
 use warnings;
 use strict;
-require 't/LintTest.pl';
+
+use lib 't/';
+use Util;
 
 checkit( [
 ], [<DATA>] );
